From 36ddde24f722da4a3cde7e0db73b0b85cd9b2fa7 Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Jul 07 2015 14:47:21 +0000
Subject: [PATCH 142/254] Fix a cache key collision bug.


---

diff --git a/hubs/widgets/__init__.py b/hubs/widgets/__init__.py
index 94ffaa2..5f4d01b 100644
--- a/hubs/widgets/__init__.py
+++ b/hubs/widgets/__init__.py
@@ -71,7 +71,8 @@ def prepare_registry(registry):
         module.data = AGPLv3(name)(module.data)
 
         # Wrap the data functions in a cache layer to be invalidated by fedmsg
-        module.data = smartcache(module)(module.data)
+        # TODO -- we could just do this with a decorator to be explicit..
+        module.data = smartcache(module.data)
 
 
 validate_registry(registry)
diff --git a/hubs/widgets/base.py b/hubs/widgets/base.py
index e0d1581..4550448 100644
--- a/hubs/widgets/base.py
+++ b/hubs/widgets/base.py
@@ -9,6 +9,9 @@ import six.moves.urllib_parse
 
 import fedmsg.config
 
+import logging
+log = logging.getLogger(__name__)
+
 config = fedmsg.config.load_config()
 cache_defaults = {
     "backend": "dogpile.cache.dbm",
@@ -48,26 +51,26 @@ def AGPLv3(name):
     return decorator
 
 
-def smartcache(module):
-    def decorator(func):
-        @wraps(func)
-        def inner(session, widget, *args, **kwargs):
-            key = cache_key_generator(module, args, kwargs)
-            creator = lambda: func(session, widget, *args, **kwargs)
-            return cache.get_or_create(key, creator)
+def smartcache(func):
+    @wraps(func)
+    def inner(session, widget, *args, **kwargs):
+        key = cache_key_generator(widget, args, kwargs)
+        creator = lambda: func(session, widget, *args, **kwargs)
+        log.debug("Accessing cache key %s", key)
+        return cache.get_or_create(key, creator)
 
-        return inner
-    return decorator
+    return inner
 
 
-def invalidate_cache(module, *args, **kwargs):
-    key = cache_key_generator(module, *args, **kwargs)
+def invalidate_cache(widget, *args, **kwargs):
+    key = cache_key_generator(widget, *args, **kwargs)
+    log.debug("Deleting cache key %s", key)
     cache.delete(key)
 
 
-def cache_key_generator(module, args, kwargs):
+def cache_key_generator(widget, args, kwargs):
     return "|".join([
-        module.__name__,
+        str(widget.idx),
         json.dumps(args),
         json.dumps(kwargs),
     ]).encode('utf-8')

